package edu.travel.web;

import com.baomidou.mybatisplus.extension.service.IService;
import edu.travel.resp.BaseResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.List;

public class BaseController<T> {
    Logger logger = LoggerFactory.getLogger(BaseController.class);
    @Autowired
    private IService<T> service;
//    @GetMapping("/download")
//    public void download(T clazz,HttpServletResponse response) throws IOException {
//        response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
//        response.setCharacterEncoding("utf-8");
//        String fileName = URLEncoder.encode("导出数据.xlsx", "UTF-8").replaceAll("\\+", "%20");
//        response.setHeader("Content-Disposition", "attachment;filename*=utf-8''" + fileName + ".xlsx");
//        List<T> list = service.list();
//        EasyExcel.write(response.getOutputStream(), clazz.getClass())
//                .sheet("数据")
//                .doWrite(list);
//    }
//    @PostMapping("/upload/excel")
//    public RPCBaseResponse uploadExcel(@RequestBody T clazz ,@RequestPart("file") MultipartFile file) throws IOException {
//        EasyExcel.read(file.getInputStream(),clazz.getClass(),new ReadListener<T>(){
//
//            @Override
//            public void invoke(T t, AnalysisContext analysisContext) {
//                saveTarget(t);
//            }
//
//            @Override
//            public void doAfterAllAnalysed(AnalysisContext analysisContext) {
//                logger.debug("读取完成");
//            }
//        })
//                .sheet()
//                .doRead();
//        return RPCBaseResponse.success();
//    }

    @GetMapping("/getById")
    public BaseResponse<T> getId(String id) {
        T byId = service.getById(id);
        return new BaseResponse(HttpStatus.OK.value(), HttpStatus.OK.getReasonPhrase(), byId);
    }
    @PostMapping("/updateById")
    @Transactional
    public BaseResponse<T> updateTargetById(@RequestBody T entity) {
        boolean update = service.updateById(entity);
        if (update) {
            return new BaseResponse<>(200,"success",entity);
        }
        return new BaseResponse(500,"error",entity);
    }
    @PostMapping("/save")
    @Transactional
    public BaseResponse<T> saveTarget(@RequestBody T entity) {
        boolean save = service.save(entity);
        if (save) {
            return new BaseResponse<>(200,"success",entity);
        }
        return new BaseResponse<>(500,"error",entity);
    }
    @PostMapping("/deleteById")
    @Transactional
    public BaseResponse<T> deleteTargetById(@RequestBody List<String> ids) {
        if (ids == null || ids.isEmpty()) {
            return new BaseResponse<>(404,"error,not found delete data",null);
        }
        boolean byIds = service.removeByIds(ids);
        if (byIds) {
            return new BaseResponse<>(200,"success",null);
        }
        return new BaseResponse<>(500,"error, delete data error",null);
    }
    @GetMapping("/list")
    public BaseResponse<List<T>> listAll() {
        List<T> list = service.list();
        if (list.isEmpty()) {
            return new BaseResponse<>(404,"error,not found delete data",null);
        }
        return new BaseResponse<>(200,"success",list);
    }



}
