package edu.travel.entity;

import lombok.Data;
import lombok.NonNull;

import java.io.Serializable;
import java.util.Date;

/**
 * 用户表
 */
@Data
public class AccountInfo extends BaseEntity implements Serializable {
    /**
     * 主键
     */
    private Long id;

    /**
     * 姓
     */
    @NonNull
    private String surname;

    /**
     * 名
     */
    @NonNull
    private String name;

    /**
     * 昵称
     */
    @NonNull
    private String nickname;

    /**
     * 性别 0男 1女
     */
    @NonNull
    private Integer sex;

    /**
     * 头像
     */
    private String avatar;

    /**
     * 手机号
     */
    @NonNull
    private String phone;

    /**
     * 地区区号
     */
    @NonNull
    private String area;

    /**
     * 生日日期
     */
    private Date birthday;

    /**
     * 用户状态：0-禁用，1-启用（默认启用）
     */
    private Integer userStatus;

    /**
     * 用户密码
     */
    @NonNull
    private String password;

    /**
     * 默认语言
     */
    private Long defaultLanguageId;

    /**
     * 微信小程序openid
     */
    private String tenantOpenId;

    /**
     * 微信小程序unionid
     */
    private String tenantUnionid;

    /**
     * token
     */
    private String token;

}