package edu.travel.controller;

import edu.travel.dto.LoginDto;
import edu.travel.dto.SendSmsDto;
import edu.travel.resp.BaseResponse;
import edu.travel.service.BtAccountInfoService;
import edu.travel.vo.BtAccountInfoVo;
import org.springframework.web.bind.annotation.*;

/**
 * LoginController 类。
 * <p>
 * 描述：
 *
 * @author huangwenwen
 * @date 2025/3/08
 */

@RestController
@RequestMapping("/baby/login")
public class LoginController {

    private BtAccountInfoService btAccountInfoService;

    /**
     * 登录
     *
     * @param loginDto
     * @return
     */
    @PostMapping("/doLogin")
    public BaseResponse<BtAccountInfoVo> doLogin(@RequestBody LoginDto loginDto) {
        return new BaseResponse<>(200,"登陆成功",btAccountInfoService.doLogin(loginDto)) ;
    }

    /**
     * 发送手机验证码
     */
    @PostMapping("/sendSms")
    public BaseResponse<String> sendSms(@RequestBody SendSmsDto sendSmsDto) {
        btAccountInfoService.sendSms(sendSmsDto);
        return new BaseResponse<>(200,"发送成功",null) ;
    }

}
